.686
.model flat,stdcall
option casemap:none

include windows.inc

include kernel32.inc
include shlwapi.inc
include masm32.inc

includelib kernel32.lib
includelib shlwapi.lib
includelib masm32.lib

; http://donkey.visualassembler.com
includelib system.lib
includelib convert.lib

dw2ascii proto dwValue:DWORD, lpBuffer:DWORD
dq2ascii proto pqwValue:DWORD, lpBuffer:DWORD
CPUSpeed proto
IsFeaturePresent proto fFeature:DWORD

IFP_MMX		equ	1
IFP_SSE		equ	2
IFP_SSE2	equ	4
IFP_SSE3	equ	8
IFP_AMD3D	equ	16
IFP_AMD3D2	equ	32

IFP_APIC	equ	65536
IFP_CMOV	equ 131072
IFP_HTT		equ 262144
IFP_TSC		equ 524288

.data?
stdout		dd ?
i1			dd ?
i2			dd ?
res			dd 16 dup (?)
m1			dd 16 dup (?)
m2			dd 16 dup (?)
count		dd ?,?
clock		dd ?,?
time		dd ?,?
tempqw		dq ?
pProc		dd ?
szBuffer	db 128 dup (?)
szDllName	db 128 dup (?)
szProcName	db 128 dup (?)

.data
szHelp		db "Usage:",13,10,9,"Test <Dll name> <Procedure name> <Repeat count> [Features needed]",13,10,0
szLibrary	db "Library:    ",0
szProcedure	db 13,10,"Procedure:  ",0
szRepeat	db 13,10,"Repeat:     ",0
szTotal		db 13,10,"Total time: ",0
szEach		db 13,10,"Each run:   ",0
szCRLF		db 13,10,13,10,0
szSep		db ", ",0
szMs		db " ms.",0
szTicks		db " clock ticks",0
szTimes		db " time(s)",0

.code

align DWORD
print proc pText:DWORD
	local dwWritten:DWORD
	
	invoke lstrlen,pText
	lea edx,dwWritten
	invoke WriteFile,stdout,pText,eax,edx,NULL
	ret
	
print endp

align DWORD
fill proc
	
	mov ebx,16
	.repeat
		.repeat
			invoke nrandom,100000h
		.until eax
		mov i1,eax
		.repeat
			invoke nrandom,100000h
		.until eax
		mov i2,eax
		fild i1
		fild i2
		fdivp st(1),st(0)
		fstp dword ptr [esi]
		add esi,4
		dec ebx
	.until zero?
	retn 0
	
fill endp

start:
invoke GetStdHandle,STD_OUTPUT_HANDLE
mov stdout,eax
invoke GetCL,1,offset szDllName
dec eax
.if !zero?
	invoke print,offset szHelp
	jmp error
.endif
invoke GetCL,2,offset szProcName
dec eax
jnz error
invoke GetCL,4,offset szBuffer
dec eax
.if zero?
	invoke atodw,offset szBuffer
	.if eax
		invoke IsFeaturePresent,eax
		test eax,eax
		jz error
	.endif
.endif
invoke GetCL,3,offset szBuffer
dec eax
jnz error
invoke atodw,offset szBuffer
test eax,eax
jz error
mov count[0],eax
invoke dw2ascii,eax,offset szBuffer
invoke GetTickCount
invoke nseed,eax
mov esi,offset m1
call fill
mov esi,offset m2
call fill
invoke LoadLibrary,offset szDllName
test eax,eax
jz error
push eax
invoke GetProcAddress,eax,offset szProcName
.if eax
	mov pProc,eax
	invoke print,offset szLibrary
	invoke PathFindFileName,offset szDllName
	invoke print,eax
	invoke print,offset szProcedure
	invoke print,offset szProcName
	invoke print,offset szRepeat
	invoke print,offset szBuffer
	invoke print,offset szTimes
	
	invoke GetTickCount
	mov clock,eax
	
	rdtsc
	mov time[0],eax
	mov time[4],edx
	
	mov ebx,count
	mov esi,pProc
	.repeat
		push offset m2
		push offset m1
		push offset res
		call esi
		sub ebx,1
	.until zero?
	
	rdtsc
	sub eax,time[0]
	sbb edx,time[4]
	mov time[0],eax
	mov time[4],edx
	
	invoke GetTickCount
	xor edx,edx
	.if eax < clock
		add edx,1
	.endif
	neg clock[0]
	mov clock[4],-1
	add clock[0],eax
	adc clock[4],edx
	
	mov eax,clock[0]
	mov eax,time[0]
	or eax,clock[4]
	or edx,time[4]
	or eax,edx
	.if !zero?
		invoke print,offset szTotal
		invoke dq2ascii,offset time,offset szBuffer
		invoke print,offset szBuffer
		invoke print,offset szTicks
		mov eax,clock[0]
		or eax,clock[4]
		.if !zero?
			invoke print,offset szSep
			invoke dq2ascii,offset clock,offset szBuffer
			invoke print,offset szBuffer
			invoke print,offset szMs
		.endif
		.if count[0] > 1
			invoke print,offset szEach
			fild qword ptr time
			fild qword ptr count
			fdivp st(1),st(0)
			fistp tempqw
			invoke dq2ascii,offset tempqw,offset szBuffer
			invoke print,offset szBuffer
			invoke print,offset szTicks
			fild clock
			fild qword ptr count
			fdivp st(1),st(0)
			fistp tempqw
			mov eax,dword ptr tempqw[0]
			or eax,dword ptr tempqw[4]
			.if !zero?
				invoke dq2ascii,offset tempqw,offset szBuffer
				invoke print,offset szSep
				invoke print,offset szBuffer
				invoke print,offset szMs
			.endif
		.endif
	.endif
	invoke print,offset szCRLF
.endif
call FreeLibrary
error:
invoke ExitProcess,0

end start
