.686
.model flat,stdcall
option casemap:none

include windows.inc

include kernel32.inc
includelib kernel32.lib

.code
align DWORD
DllEntryPoint proc hinstDLL:DWORD, fdwReason:DWORD, lpvReserved:DWORD
	
	push TRUE
	pop eax
	ret
	
DllEntryPoint endp

align DWORD
pdixon1 proc uses ebx esi edi p_res:DWORD, p_m1:DWORD, p_m2:DWORD
	
	;by pdixon
	;..a few comments on the code
	;It's not optimised but it works so it's a starting point.
	;It runs on my PC in 170clks.
	;
	;Suggested improvements would be to unroll the inner loop (drops it to 135clks)
	;
	;Note that in each inner loop it reloads both row and column each time to multiply them.. but ESI never changes in the
	;inner loop so the 4 operands addressed by ESI could be loaded ahead of the loop and reused 4 times within it. There's
	;plenty space on the FPU stack for this.
	
	mov eax,p_m1
	mov ebx,p_m2
	mov edx,p_res
	
	;on entry
	;eax points to first element of A()
	;ebx points to first element of B()
	;edx points to first element of D()
	;routine calculates D() = A()*B() where all 3 arrays are 4x4 elements of size SINGLE (4 byte floats)
	
	mov esi,12     ;for 4 rows (0-3) each element is 4 bytes
	
	lp2:
	mov edi,12     ;for 4 columns (0-3) each element is 4 bytes
	
	lp1:
	fld qword ptr [ebx+esi*4]      ;do first mul
	fld qword ptr [eax+edi]
	fmulp st(1),st(0)
	
	fld qword ptr [ebx+esi*4+4]      ;do 2nd mul
	fld qword ptr [eax+edi+16]
	fmulp st(1),st(0)
	faddp st(1),st(0)
	
	fld qword ptr [ebx+esi*4+8]      ;do 3rd mul
	fld qword ptr [eax+edi+32]
	fmulp st(1),st(0)
	faddp st(1),st(0)
	
	fld qword ptr [ebx+esi*4+12]      ;do 4th mul
	fld qword ptr [eax+edi+48]
	fmulp st(1),st(0)
	faddp st(1),st(0)
	                                   
	lea ecx,[esi*4+edi]               ;store first result
	fstp qword ptr [edx+ecx]
	
	sub edi,4                         ;end inner loop
	jae lp1
	
	sub esi,4                         ;end outer loop
	jae lp2
	
	;done
	
	mov eax,p_res
	ret
	
pdixon1 endp

end DllEntryPoint
